/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet;

import java.util.Collection;
import javax.annotation.Nonnull;
import javax.annotation.concurrent.Immutable;
import java.util.Map;
import it.tidalwave.util.Id;
import it.tidalwave.util.Key;
import it.tidalwave.semantic.EntityWithProperties;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Immutable
public class FactSheet extends EntityWithProperties<FactSheet>
  {
    public static final Class<FactSheet> FactSheet = FactSheet.class;
    
    // FIXME: what's this? What's used for? Can be replaced by a standard vocabulary item?
    public static final Id ID_DESCRIPTION = new Id("http://bluebill.tidalwave.it/rdf/taxo/2010/08/28#description");
    public static final Key<String> DESCRIPTION = new Key<String>(ID_DESCRIPTION);

    public FactSheet (final @Nonnull Id id)
      {
        super(id);
      }

    private FactSheet (final @Nonnull Id id,
                       final @Nonnull Map<Key<?>, Object> propertyMap,
                       final @Nonnull Object[] capabilities) 
      {
        super(id, propertyMap, capabilities);
      } 

    @Override @Nonnull
    protected FactSheet clone (final @Nonnull Id id,
                               final @Nonnull Map<Key<?>, Object> propertyMap,
                               final @Nonnull Object[] capabilities)
      {
        return new FactSheet(id, propertyMap, capabilities);
      }

    @Nonnull
    public FactSheet mergedWith (final @Nonnull FactSheet factSheet) // FIXME: could be pushed up?
      {
        FactSheet result = this;
        
        for (final Key<?> key : factSheet.getKeys())
          {
            final Collection values = factSheet.getMultiple(key);
            result = result.with(key, values);
          }
        
        return result;  
      }
  }
